VERSION 5.00
Begin VB.Form fMain 
   AutoRedraw      =   -1  'True
   Caption         =   "Form1"
   ClientHeight    =   10170
   ClientLeft      =   120
   ClientTop       =   420
   ClientWidth     =   16470
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   678
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   1098
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdEDGES 
      Caption         =   "RGB EDGES"
      Height          =   615
      Left            =   14280
      TabIndex        =   6
      Top             =   5280
      Width           =   2100
   End
   Begin VB.CommandButton cmdFLIP 
      Caption         =   "RGB FLIP"
      Height          =   615
      Left            =   14280
      TabIndex        =   5
      Top             =   4440
      Width           =   2100
   End
   Begin VB.CommandButton cmdRGBswap 
      Caption         =   "RGB swap"
      Height          =   615
      Left            =   14280
      TabIndex        =   4
      Top             =   3600
      Width           =   2100
   End
   Begin VB.CommandButton cmd3 
      Caption         =   "LENS"
      Height          =   615
      Left            =   14280
      TabIndex        =   3
      Top             =   2760
      Width           =   2100
   End
   Begin VB.PictureBox PIC 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   9615
      Left            =   120
      Picture         =   "fMain.frx":0000
      ScaleHeight     =   641
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   937
      TabIndex        =   2
      Top             =   120
      Width           =   14055
   End
   Begin VB.CommandButton cmdRawBoxBlur 
      Caption         =   "BW Poor BOX BLUR"
      Height          =   615
      Left            =   14280
      TabIndex        =   1
      Top             =   120
      Width           =   2100
   End
   Begin VB.CommandButton cmdInvert 
      Caption         =   "BW Invert"
      Height          =   615
      Left            =   14280
      TabIndex        =   0
      Top             =   960
      Width           =   2100
   End
End
Attribute VB_Name = "fMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public WithEvents Master1 As cIPCMaster
Attribute Master1.VB_VarHelpID = -1
Public WithEvents Master2 As cIPCMaster
Attribute Master2.VB_VarHelpID = -1
Public WithEvents Master3 As cIPCMaster
Attribute Master3.VB_VarHelpID = -1
Public WithEvents Master4 As cIPCMaster
Attribute Master4.VB_VarHelpID = -1


Private Sub cmdEDGES_Click()
    Dim INP1() As Single
    Dim INP2() As Single
    Dim INP3() As Single
    Dim out1() As Single
    Dim out2() As Single
    Dim out3() As Single

    Dim JobParameters As tParams

    SETUPProcessesMemory fMain.PIC.Width - 1, fMain.PIC.Height - 1, 3, 3

    GetRGBPixelValues INP1, INP2, INP3

    Me.Caption = "Start JOBS"
    StartJOBS_33 JobParameters, INP1(), INP2(), INP3(), out1(), out2(), out3(), 6

    Me.Caption = "End JOBS"

    '    RawDrawOutput Out
    Output3ToPIC PIC.Image.Handle, out1, out2, out3
    PIC.Refresh

    Me.Caption = "End DRAW"
End Sub

Private Sub cmdFLIP_Click()
    Dim INP1() As Single
    Dim INP2() As Single
    Dim INP3() As Single
    Dim out1() As Single
    Dim out2() As Single
    Dim out3() As Single

    Dim JobParameters As tParams

    SETUPProcessesMemory fMain.PIC.Width - 1, fMain.PIC.Height - 1, 3, 3

    GetRGBPixelValues INP1, INP2, INP3


    Me.Caption = "Start JOBS"
    StartJOBS_33 JobParameters, INP1(), INP2(), INP3(), out1(), out2(), out3(), 5

    Me.Caption = "End JOBS"

    '    RawDrawOutput Out
    Output3ToPIC PIC.Image.Handle, out1, out2, out3
    PIC.Refresh

    Me.Caption = "End DRAW"
End Sub

Private Sub cmdRawBoxBlur_Click()
    Dim Inp() As Single
    Dim Out() As Single
    Dim JobParameters As tParams

    SETUPProcessesMemory fMain.PIC.Width - 1, fMain.PIC.Height - 1, 1, 1

    GetGrayPixels Inp
    JobParameters.P(1) = 10    'Radius

    Me.Caption = "Start JOBS"
    StartJOBS_11 JobParameters, Inp(), Out(), 1, 2   ' Job Type 1  (2 iterations)
    Me.Caption = "End JOBS"

    '    RawDrawOutput Out
    Output1ToPIC PIC.Image.Handle, Out
    PIC.Refresh
    Me.Caption = "End DRAW"

End Sub


Private Sub cmdInvert_Click()
    Dim Inp() As Single
    Dim Out() As Single
    Dim JobParameters As tParams

    SETUPProcessesMemory fMain.PIC.Width - 1, fMain.PIC.Height - 1, 1, 1

    GetGrayPixels Inp

    JobParameters.P(1) = 5

    Me.Caption = "Start JOBS"
    StartJOBS_11 JobParameters, Inp(), Out(), 2    ' JOB Type 2
    Me.Caption = "End JOBS"

    '    RawDrawOutput Out
    Output1ToPIC PIC.Image.Handle, Out
    PIC.Refresh

    Me.Caption = "End DRAW"

End Sub

Private Sub cmd3_Click()
    ' LENS
    
    Dim INP1() As Single
    Dim INP2() As Single
    Dim INP3() As Single
    Dim out1() As Single
    Dim out2() As Single
    Dim out3() As Single

    Dim JobParameters As tParams

    SETUPProcessesMemory fMain.PIC.Width - 1, fMain.PIC.Height - 1, 3, 3

    GetRGBPixelValues INP1, INP2, INP3
    JobParameters.P(1) = 25

    Me.Caption = "Start JOBS"
    StartJOBS_33 JobParameters, INP1(), INP2(), INP3(), out1(), out2(), out3(), 3 'Do JOB3

    Me.Caption = "End JOBS"

    '    RawDrawOutput Out
    Output3ToPIC PIC.Image.Handle, out1, out2, out3
    PIC.Refresh

    Me.Caption = "End DRAW"
End Sub

Private Sub cmdRGBswap_Click()

    Dim INP1() As Single
    Dim INP2() As Single
    Dim INP3() As Single
    Dim out1() As Single
    Dim out2() As Single
    Dim out3() As Single

    Dim JobParameters As tParams

    SETUPProcessesMemory fMain.PIC.Width - 1, fMain.PIC.Height - 1, 3, 3

    GetRGBPixelValues INP1, INP2, INP3


    Me.Caption = "Start JOBS"
    StartJOBS_33 JobParameters, INP1(), INP2(), INP3(), out1(), out2(), out3(), 4 'Do JOB 4

    Me.Caption = "End JOBS"

    '    RawDrawOutput Out
    Output3ToPIC PIC.Image.Handle, out1, out2, out3
    PIC.Refresh

    Me.Caption = "End DRAW"

End Sub


Private Sub Form_Load()

    PIC.Width = PIC.Width - (PIC.Width Mod 4)
    PIC.Height = PIC.Height - (PIC.Height Mod 4)    'Must be multiple of 4

    '    WorkerAreaW = PIC.Width - 1
    '    WorkerAreaH = PIC.Height - 1

    STARTUPProcesses


End Sub






Private Sub Form_Unload(Cancel As Integer)
    If Not (Master1 Is Nothing) Then Master1.CloseWorkerGracefully 1     'graceful close with a timeout of 1 second
    If Not (Master2 Is Nothing) Then Master2.CloseWorkerGracefully 1
    If Not (Master3 Is Nothing) Then Master3.CloseWorkerGracefully 1
    If Not (Master4 Is Nothing) Then Master4.CloseWorkerGracefully 1
    End
End Sub


Private Sub Master1_JobStateChanged(ByVal JobState As eJobState)
'If (Master1.JobState = jobFinished) And (Master2.JobState = jobFinished) Then DrawOUT
    ProcessDone1 = (Master1.JobState = jobFinished)
End Sub


Private Sub Master2_JobStateChanged(ByVal JobState As eJobState)
'If (Master1.JobState = jobFinished) And (Master2.JobState = jobFinished) Then DrawOUT
    ProcessDone2 = (Master2.JobState = jobFinished)
End Sub

Private Sub Master3_JobStateChanged(ByVal JobState As eJobState)
    ProcessDone3 = (Master3.JobState = jobFinished)
End Sub

Private Sub Master4_JobStateChanged(ByVal JobState As eJobState)
    ProcessDone4 = (Master4.JobState = jobFinished)
End Sub
