Attribute VB_Name = "mIPCMultiprocessManager"
Option Explicit

Private WD  As tWorkDATA

Private ProcessPath As String

'''Public Const WorkerAreaW As Long = 511
'''Public Const WorkerAreaH As Long = 255  ' Must be multple of 4 . and then -1  (256 -1)
''
''Public WorkerAreaW As Long
''Public WorkerAreaH As Long   ' Must be multple of 4 . and then -1  (256 -1)


Public NCORES As Long

Public ProcessDone1 As Boolean
Public ProcessDone2 As Boolean
Public ProcessDone3 As Boolean
Public ProcessDone4 As Boolean

Private MemoryToReserve As Long
Private OldMemoryToReserve As Long


'To copy 2D Arrays
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByVal pDest As Long, ByVal pSrc As Long, ByVal ByteLen As Long)
Private Declare Function GetMem4 Lib "MSVBVM60" (ByVal Src As Long, ByVal dest As Long) As Long
Private Declare Function ArrPtr Lib "MSVBVM60" Alias "VarPtr" (arr() As Any) As Long


Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Sub Wait(ByVal msec As Long)
    Sleep msec: DoEvents
End Sub




Public Function ArrayExists(ByVal ppArray) As Long
    GetMem4 ppArray, VarPtr(ArrayExists)
End Function

Public Sub ArrCopyDS(dest() As Single, Src() As Single)
    Dim Size As Long
    Dim W   As Long
    Dim H   As Long
    W = UBound(Src, 1)
    H = UBound(Src, 2)
    Size = (W + 1) * (H + 1) * LenB(Src(0, 0))

    If ArrayExists(ArrPtr(dest)) Then
        '    If Not ((Not Dest) = -1) Then
        If (W - UBound(dest, 1)) Or (H - UBound(dest, 2)) Then    'If Dest Exists but has different size
            ReDim dest(W, H)
        End If
    Else
        '''Array DEST has No Dimension
        ReDim dest(W, H)
    End If

    CopyMemory ByVal VarPtr(dest(0, 0)), ByVal VarPtr(Src(0, 0)), Size

End Sub



Public Sub STARTUPProcesses()

    NCORES = Environ("NUMBER_OF_PROCESSORS")
    If NCORES > 4 Then NCORES = 4
    If NCORES = 3 Then NCORES = 2

    'NCORES = 4    'for test

    ProcessPath = App.Path & "\" & "Worker.exe"

    SETUPProcessesMemory fMain.PIC.Width - 1, fMain.PIC.Height - 1, 1, 1

End Sub

Public Sub SETUPProcessesMemory(W As Long, H As Long, NofInputs As Long, NofOutputs As Long)
    Dim InputMEM As Long
    Dim OutputMEM As Long

    Dim PixArea As Long
    '
    PixArea = (W + 1) * (H + 1) * 4

    InputMEM = PixArea * NofInputs
    OutputMEM = (PixArea \ NCORES) * NofOutputs

    MemoryToReserve = LenB(WD) + InputMEM + OutputMEM

    If OldMemoryToReserve = 0 Then
        If NCORES >= 1 Then Set fMain.Master1 = CreateWorkerProcess(MemoryToReserve)
        If NCORES >= 2 Then Set fMain.Master2 = CreateWorkerProcess(MemoryToReserve)
        If NCORES >= 3 Then Set fMain.Master3 = CreateWorkerProcess(MemoryToReserve)
        If NCORES >= 4 Then Set fMain.Master4 = CreateWorkerProcess(MemoryToReserve)
        OldMemoryToReserve = MemoryToReserve
    Else
        If MemoryToReserve > OldMemoryToReserve Then

            If Not (fMain.Master1 Is Nothing) Then fMain.Master1.CloseWorkerGracefully: Set fMain.Master1 = Nothing
            If Not (fMain.Master2 Is Nothing) Then fMain.Master2.CloseWorkerGracefully: Set fMain.Master2 = Nothing
            If Not (fMain.Master3 Is Nothing) Then fMain.Master3.CloseWorkerGracefully: Set fMain.Master3 = Nothing
            If Not (fMain.Master4 Is Nothing) Then fMain.Master4.CloseWorkerGracefully: Set fMain.Master4 = Nothing
            '            Wait 1000
            If NCORES >= 1 Then Set fMain.Master1 = CreateWorkerProcess(MemoryToReserve)
            If NCORES >= 2 Then Set fMain.Master2 = CreateWorkerProcess(MemoryToReserve)
            If NCORES >= 3 Then Set fMain.Master3 = CreateWorkerProcess(MemoryToReserve)
            If NCORES >= 4 Then Set fMain.Master4 = CreateWorkerProcess(MemoryToReserve)
            OldMemoryToReserve = MemoryToReserve
        Else
            'Already Created
        End If

    End If

End Sub

Private Function CreateWorkerProcess(MemSizeToReserve) As cIPCMaster
    Set CreateWorkerProcess = New cIPCMaster
    If CreateWorkerProcess.InitAndBindWorkerTo(fMain, MemSizeToReserve, ProcessPath) = 0 Then
        MsgBox "To be able to start a Worker, this Project needs to be compiled first"
    End If

End Function





Public Sub StartJOBS_11(parameters As tParams, Inp() As Single, Out() As Single, JobType As Long, Optional NIterations As Long = 1)
' Start JOBS with 1 Input and 1 output

    Dim NofIterations As Long

    Dim I   As Long
    Dim P   As Long

    Dim W   As Long
    Dim H   As Long

    Dim Offset As Long
    Dim ProcOutSize As Long

    Dim InputArea As Long

    NofIterations = NIterations
    If NofIterations < 1 Then NofIterations = 1

    W = UBound(Inp, 1)
    H = UBound(Inp, 2)

    ReDim Out(W, H)

    InputArea = (W + 1) * (H + 1) * 4    '(4)=Using Singles
    '
    For I = 1 To NofIterations
        If NCORES >= 1 Then StartStripeJob1Input fMain.Master1, Inp, 1, NCORES, JobType, parameters: ProcessDone1 = False
        If NCORES >= 2 Then StartStripeJob1Input fMain.Master2, Inp, 2, NCORES, JobType, parameters: ProcessDone2 = False
        If NCORES >= 3 Then StartStripeJob1Input fMain.Master3, Inp, 3, NCORES, JobType, parameters: ProcessDone3 = False
        If NCORES >= 4 Then StartStripeJob1Input fMain.Master4, Inp, 4, NCORES, JobType, parameters: ProcessDone4 = False

        Select Case NCORES
            Case 1
                Do
                    Wait 100
                Loop While Not (ProcessDone1)
            Case 2
                Do
                    Wait 100
                Loop While Not (ProcessDone1 And ProcessDone2)
            Case 3
                Do
                    Wait 100
                Loop While Not (ProcessDone1 And ProcessDone2 And ProcessDone3)
            Case 4
                Do
                    Wait 100
                Loop While Not (ProcessDone1 And ProcessDone2 And ProcessDone3 And ProcessDone4)
        End Select
        ' ALL JOBS COMPLETED

        '-------------------
        ' Read 2D output parts of Processes
        ' And Put them on "OUT" Array at offset: WD.StartY
        ' (Process output size is given by InputArea \ WD.NProcesses )

        fMain.Master1.UserDataRead VarPtr(WD), LenB(WD)  ' to get WD.NProcesses
        Offset = LenB(WD) + InputArea
        ProcOutSize = InputArea \ WD.NProcesses

        For P = 1 To WD.NProcesses
            If P = 1 Then
                fMain.Master1.UserDataRead VarPtr(WD), LenB(WD)    'to get WD.StartY
                fMain.Master1.UserDataRead VarPtr(Out(0, WD.StartY)), ProcOutSize, Offset
            End If
            If P = 2 Then
                fMain.Master2.UserDataRead VarPtr(WD), LenB(WD)    'to get WD.StartY
                fMain.Master2.UserDataRead VarPtr(Out(0, WD.StartY)), ProcOutSize, Offset
            End If
            If P = 3 Then
                fMain.Master3.UserDataRead VarPtr(WD), LenB(WD)    'to get WD.StartY
                fMain.Master3.UserDataRead VarPtr(Out(0, WD.StartY)), ProcOutSize, Offset
            End If
            If P = 4 Then
                fMain.Master4.UserDataRead VarPtr(WD), LenB(WD)    'to get WD.StartY
                fMain.Master4.UserDataRead VarPtr(Out(0, WD.StartY)), ProcOutSize, Offset
            End If
        Next

        If NofIterations > 1 Then
            'Inp = Out    'ArrcopyDS
            ArrCopyDS Inp, Out   'Fast Copy Output to Input to interate again (I don't need to preserve Input values)
        End If

    Next

End Sub
Public Sub StartJOBS_33(parameters As tParams, _
                        INP1() As Single, _
                        INP2() As Single, _
                        INP3() As Single, _
                        out1() As Single, _
                        out2() As Single, _
                        out3() As Single, JobType As Long, Optional NIterations As Long = 1)
' Start JOBS with 3 Inputs and 3 outputs

    Dim NofIterations As Long

    Dim I   As Long
    Dim P   As Long

    Dim W   As Long
    Dim H   As Long

    Dim Offset As Long
    Dim ProcOutSize As Long

    Dim InputArea As Long
    Dim OutputArea As Long

    NofIterations = NIterations
    If NofIterations < 1 Then NofIterations = 1

    W = UBound(INP1, 1)
    H = UBound(INP1, 2)

    ReDim out1(W, H)
    ReDim out2(W, H)
    ReDim out3(W, H)

    InputArea = (W + 1) * (H + 1) * 4    '(4)=Using Singles

    '
    For I = 1 To NofIterations
        If NCORES >= 1 Then StartStripeJob3Inputs fMain.Master1, INP1, INP2, INP3, 1, NCORES, JobType, parameters: ProcessDone1 = False
        If NCORES >= 2 Then StartStripeJob3Inputs fMain.Master2, INP1, INP2, INP3, 2, NCORES, JobType, parameters: ProcessDone2 = False
        If NCORES >= 3 Then StartStripeJob3Inputs fMain.Master3, INP1, INP2, INP3, 3, NCORES, JobType, parameters: ProcessDone3 = False
        If NCORES >= 4 Then StartStripeJob3Inputs fMain.Master4, INP1, INP2, INP3, 4, NCORES, JobType, parameters: ProcessDone4 = False

        Select Case NCORES
            Case 1
                Do
                    Wait 100
                Loop While Not (ProcessDone1)
            Case 2
                Do
                    Wait 100
                Loop While Not (ProcessDone1 And ProcessDone2)
            Case 3
                Do
                    Wait 100
                Loop While Not (ProcessDone1 And ProcessDone2 And ProcessDone3)
            Case 4
                Do
                    Wait 100
                Loop While Not (ProcessDone1 And ProcessDone2 And ProcessDone3 And ProcessDone4)
        End Select
        ' ALL JOBS COMPLETED

        '-------------------
        ' Read 2D output parts of Processes
        ' And Put them on "OUT" Array at offset: WD.StartY
        ' (Process output size is given by InputArea \ WD.NProcesses )

        fMain.Master1.UserDataRead VarPtr(WD), LenB(WD)  ' to get WD.NProcesses
        Offset = LenB(WD) + InputArea * 3
        ProcOutSize = InputArea \ WD.NProcesses

        'Read Workers Output and put them to Out arrays
        For P = 1 To WD.NProcesses
            If P = 1 Then
                fMain.Master1.UserDataRead VarPtr(WD), LenB(WD)    'to get WD.StartY
                fMain.Master1.UserDataRead VarPtr(out1(0, WD.StartY)), ProcOutSize, Offset
                fMain.Master1.UserDataRead VarPtr(out2(0, WD.StartY)), ProcOutSize, Offset + ProcOutSize
                fMain.Master1.UserDataRead VarPtr(out3(0, WD.StartY)), ProcOutSize, Offset + ProcOutSize * 2
            End If
            If P = 2 Then
                fMain.Master2.UserDataRead VarPtr(WD), LenB(WD)    'to get WD.StartY
                fMain.Master2.UserDataRead VarPtr(out1(0, WD.StartY)), ProcOutSize, Offset
                fMain.Master2.UserDataRead VarPtr(out2(0, WD.StartY)), ProcOutSize, Offset + ProcOutSize
                fMain.Master2.UserDataRead VarPtr(out3(0, WD.StartY)), ProcOutSize, Offset + ProcOutSize * 2
            End If
            If P = 3 Then
                fMain.Master3.UserDataRead VarPtr(WD), LenB(WD)    'to get WD.StartY
                fMain.Master3.UserDataRead VarPtr(out1(0, WD.StartY)), ProcOutSize, Offset
                fMain.Master3.UserDataRead VarPtr(out2(0, WD.StartY)), ProcOutSize, Offset + ProcOutSize
                fMain.Master3.UserDataRead VarPtr(out3(0, WD.StartY)), ProcOutSize, Offset + ProcOutSize * 2
            End If
            If P = 4 Then
                fMain.Master4.UserDataRead VarPtr(WD), LenB(WD)    'to get WD.StartY
                fMain.Master4.UserDataRead VarPtr(out1(0, WD.StartY)), ProcOutSize, Offset
                fMain.Master4.UserDataRead VarPtr(out2(0, WD.StartY)), ProcOutSize, Offset + ProcOutSize
                fMain.Master4.UserDataRead VarPtr(out3(0, WD.StartY)), ProcOutSize, Offset + ProcOutSize * 2
            End If
        Next

        If NofIterations > 1 Then
            'Inp = Out    'ArrcopyDS
            ArrCopyDS INP1, out1   'Fast Copy Output to Input to interate again (I don't need to preserve Input values)
            ArrCopyDS INP2, out2   '
            ArrCopyDS INP3, out3   '
        End If

    Next

End Sub



Private Sub StartStripeJob1Input(M As cIPCMaster, sngINP() As Single, Proc As Long, ofProc As Long, JobType As Long, Params As tParams)
' JOBS with 1 Input

    With WD
        .W = UBound(sngINP, 1)
        .H = UBound(sngINP, 2)
        .CurrProcess = Proc
        .NProcesses = ofProc
        .JobType = JobType
        .JobParams = Params
    End With


    M.UserDataWrite VarPtr(WD), LenB(WD)    'Write WD
    M.UserDataWrite VarPtr(sngINP(0, 0)), (WD.W + 1) * (WD.H + 1) * 4, LenB(WD)    'Write 2D Input Array

    M.JobState = jobPrepared

End Sub
Private Sub StartStripeJob2Inputs(M As cIPCMaster, _
                            INP1() As Single, _
                            INP2() As Single, _
                            Proc As Long, ofProc As Long, JobType As Long, Params As tParams)
' JOBS with 2 Inputs

    Dim InputArea As Long

    With WD
        .W = UBound(INP1, 1)
        .H = UBound(INP1, 2)
        .CurrProcess = Proc
        .NProcesses = ofProc
        .JobType = JobType
        .JobParams = Params
    End With

    InputArea = (WD.W + 1) * (WD.H + 1) * 4

    M.UserDataWrite VarPtr(WD), LenB(WD)    'Write WD
    M.UserDataWrite VarPtr(INP1(0, 0)), InputArea, LenB(WD)    'Write 2D Input Array
    M.UserDataWrite VarPtr(INP2(0, 0)), InputArea, LenB(WD) + InputArea

    M.JobState = jobPrepared

End Sub
Private Sub StartStripeJob3Inputs(M As cIPCMaster, _
                            INP1() As Single, _
                            INP2() As Single, _
                            INP3() As Single, _
                            Proc As Long, ofProc As Long, JobType As Long, Params As tParams)
' JOBS with 3 Inputs

    Dim InputArea As Long

    With WD
        .W = UBound(INP1, 1)
        .H = UBound(INP1, 2)
        .CurrProcess = Proc
        .NProcesses = ofProc
        .JobType = JobType
        .JobParams = Params
    End With

    InputArea = (WD.W + 1) * (WD.H + 1) * 4

    M.UserDataWrite VarPtr(WD), LenB(WD)    'Write WD
    M.UserDataWrite VarPtr(INP1(0, 0)), InputArea, LenB(WD)    'Write 2D Input Array
    M.UserDataWrite VarPtr(INP2(0, 0)), InputArea, LenB(WD) + InputArea
    M.UserDataWrite VarPtr(INP3(0, 0)), InputArea, LenB(WD) + InputArea * 2

    M.JobState = jobPrepared

End Sub


